#!/usr/bin/perl
#################
#
# mysql.cgi -- Connect to MySQL database
#
# Author:    Stefan Warten <sw@warten.de>
# Copyright: (C) 2007 Stefan Warten
# Licence:   GPL-2 <http://www.gnu.org/copyleft/gpl.html>
#

use strict;
use warnings;
use DBI;
use CGI;
use CGI::Carp qw(fatalsToBrowser);

my $dbname = "";
my $dbuser = "";
my $dbpass = "";
my $dbhost = "localhost";
my $dbtype = "mysql";

my $query = new CGI;

print $query->header;
print $query->start_html( -title => "Connect to MySQL" );

if (not $query->param()) {
    print $query->start_form( 'POST', $query->url( { -relative => 1 } ) );
    print $query->p(
        "Database",
        $query->br,
        $query->textfield(
            -name      => "dbname",
            -default   => "$dbname",
            -size      => 40,
        ),
        $query->br,
        "Username",
        $query->br,
        $query->textfield(
            -name      => "dbuser",
            -default   => "$dbuser",
            -size      => 40,
        ),
        $query->br,
        "Password",
        $query->br,
        $query->textfield(
            -name      => "dbpass",
            -default   => "$dbpass",
            -size      => 40,
        ),
        $query->br,
        "Hostname",
        $query->br,
        $query->textfield(
            -name      => "dbhost",
            -default   => "$dbhost",
            -size      => 40,
        ),
        $query->br,
    );
    print $query->p( $query->submit("Connect to database") );
    print $query->end_form;
}
else {
	$dbname = $query->param('dbname');
    $dbuser = $query->param('dbuser');
    $dbpass = $query->param('dbpass');
    $dbhost = $query->param('dbhost');

    my $dsn = "DBI:$dbtype:$dbname:$dbhost";
    my $dbh = DBI->connect($dsn, $dbuser, $dbpass);
    if (defined($dbh) and $dbh ne "" ) {
        print $query->p("Connection to database was successful.");
        $dbh->disconnect();
    } else {
        print $query->p("Cannot connect to database. $DBI::errstr");
    }
    print $query->p(
        $query->a( { -href => $query->url( { -relative => 1 } ) }, "back" )
    );

}

print $query->end_html();
