#!/usr/bin/perl
###############
#
# sendmail.cgi -- Send mail using the sendmail wrapper
#
# Author:    Stefan Warten <sw@warten.de>
# Copyright: (C) 2007 Stefan Warten
# Licence:   GPL-2 <http://www.gnu.org/copyleft/gpl.html>
#

use strict;
use warnings;
use CGI;
use CGI::Carp qw(fatalsToBrowser);

# Path to sendmail. Try `which sendmail`.
my $sendmail  = "/usr/sbin/sendmail";

my $MAIL_FROM = "sender\@example.com";
my $RCPT_TO   = "recipient\@example.com";

my $subject   = "This message is for testing purposes";
my $body      = "This message is for testing purposes. Please ignore it.";

my $query = new CGI;

print $query->header;
print $query->start_html( -title => "Send mail" );

my $to   = $query->param('To');
my $from = $query->param('From');

if ( isEmail($to) and isEmail($from) ) {
    open( MAIL, "|$sendmail -t" ) or die("Error: $!");
    print MAIL qq|To: <$to>\n|;
    print MAIL qq|From: <$from>\n|;
    print MAIL qq|Subject: $subject\n\n|;
    print MAIL $body;
    close(MAIL);
    print $query->p("An e-mail has been sent to $to.");    
    print $query->p(
        $query->a( { -href => $query->url( { -relative => 1 } ) }, "back" )
    );
}
else {
    print $query->startform( 'POST', $query->url( { -relative => 1 } ) );
    print $query->p(
        "To:",
        $query->br(),
        $query->textfield(
            -name      => "To",
            -default   => "$RCPT_TO",
            -size      => 40,
            -maxlength => 255
        )
    );
    print $query->p(
        "From:",
        $query->br(),
        $query->textfield(
            -name      => "From",
            -default   => "$MAIL_FROM",
            -size      => 40,
            -maxlength => 255
        )
    );
    print $query->p( $query->submit("Send mail") );
    print $query->endform;
}

print $query->end_html;

sub isEmail {
    my $nonascii = "\x80-\xff";    # Non-ASCII-Chars are not allowed
    my $nqtext       = "[^\\\\$nonascii\015\012\"]";
    my $qchar        = "\\\\[^$nonascii]";
    my $protocol     = '(?:mailto:)';
    my $normuser     = '[a-zA-Z0-9][a-zA-Z0-9_.-]*';
    my $quotedstring = "\"(?:$nqtext|$qchar)+\"";
    my $user_part    = "(?:$normuser|$quotedstring)";
    my $dom_mainpart = '[a-zA-Z0-9][a-zA-Z0-9._-]*\\.';
    my $dom_subpart  = '(?:[a-zA-Z0-9][a-zA-Z0-9._-]*\\.)*';
    my $dom_tldpart  = '[a-zA-Z]{2,5}';
    my $domain_part  = "$dom_subpart$dom_mainpart$dom_tldpart";
    my $MailRegEx    = "$protocol?$user_part\@$domain_part";
    my $email        = shift;
    return $email =~ /^$MailRegEx$/o;
}
