#!/usr/bin/perl
###############
#
# upload.cgi -- Upload file
#
# Author:    Stefan Warten <sw@warten.de>
# Copyright: (C) 2007 Stefan Warten
# Licence:   GPL-2 <http://www.gnu.org/copyleft/gpl.html>
#

use strict;
use warnings;
use CGI;
use CGI::Carp qw(fatalsToBrowser);

my $query = new CGI;

print $query->header;
print $query->start_html( -title => "Upload file" );

if (not $query->param()) {
    print $query->start_multipart_form( 'POST', $query->url( { -relative => 1 } ) );
    print $query->p(
        "File:",
        $query->filefield(
            -name      => "file",
            -size      => 40,
        )
    );
    print $query->p( $query->submit("Upload file") );
    print $query->end_form;
}
else {
    my $file = $query->param('file');
    my $handle = $query->upload('file');
    my $upload_dir = $ENV{'DOCUMENT_ROOT'};
    $file =~ s/.*[\/\\](.*)/$1/; 

    open (FILE, ">$upload_dir/$file")
        or die("Cannot open $file: $!");
    binmode(FILE);

    while(<$handle>){
        print FILE $_;
    }
    close( FILE);
    print $query->p( "File has been uploaded successfully to $upload_dir.",
            $query->br,
            $query->a( { -href => $query->url( { -relative => 1 } ) }, "back" )
    );

}

print $query->end_html;
